import type { ObjectKey } from "./types";
export declare class UnPartialError extends Error {
    key: ObjectKey;
    partialObject: object;
    constructor(key: ObjectKey, partialObject: object);
}
export type UnPartial<T extends object, K extends keyof T> = T & {
    [P in K]-?: Exclude<T[P], undefined>;
};
export declare function unPartial<T extends object, K extends keyof T>(partialObject: T, keys: K[]): UnPartial<T, K>;
